package nl.logicacmg.grid.client;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;

import javax.swing.JPanel;

/**
 * Utility class for Swing Clients
 * @modelguid {B7C0F64A-5835-4DD1-9287-B519A3DDC3D8}
 */

public class ImagePanel extends JPanel {
	private Image image;
	private boolean stretch;
	private int x1,y1,x2,y2;
	
	public ImagePanel() {
		setBackground(Color.black);
	}

	public void setImage(Image image, boolean stretch) {
		this.image = image;
		this.stretch = stretch;
		x1=-1;
		repaint();
	}

	public void drawRect(int x1, int y1, int x2, int y2) {
	    this.x1=x1;
	    this.x2=x2;
	    this.y1=y1;
	    this.y2=y2;
		repaint();
	}
	
	public Image getImage(){
		return image;
	}

	public void paint(Graphics g) {
		super.paint(g);
		if (stretch) {
			g.drawImage(image, 0, 0, getWidth(), getHeight(), null);
		} else {
			int cx = (getWidth() - image.getWidth(null)) / 2;
			int cy = (getHeight() - image.getHeight(null)) / 2;

			g.drawImage(image, cx, cy, null);
		}
		if (x1>-1){
			g.setColor(Color.white);
			g.drawRect(x1,y1,x2,y2);
			g.drawRect(x1+1,y1+1,x2-1,y2-1);
		}
	}

}
