package nl.logicacmg.grid.client;


import org.apache.log4j.Logger;

public class Launcher extends Thread{
	private String id;
	private boolean active = true;
	private String servicename;
	private String reply;
	private String request;
	private GateClient gateclient;
	private Parameters parameters;
	private String gateaddress;
	
	Logger logger=Logger.getLogger(Launcher.class);
	
	public Launcher(String id, String gateaddress, String servicename) {
		super();
		parameters=new Parameters();
		this.id = id;
		this.gateaddress=gateaddress;
		this.servicename = servicename;
		try{
			Class gateclientclass=Class.forName(PropertyManager.getGateClientClass());
				gateclient=(GateClient)gateclientclass.newInstance();
			logger.debug("Launcher created at "+gateaddress+" for servicename "+servicename+" using "+gateclientclass.getName());
		} catch (ClassNotFoundException e){
			logger.error("cannot find gateclient class, check your properties file.");
	    } catch (InstantiationException e) {
	    	logger.error("instantiation exception, cannot create gateclient class, check your properties file");
		} catch (IllegalAccessException e) {
			logger.error("instantiation exception, cannot create gateclient class, check your properties file");
	  }
	
		
	}
	
	public Parameters getParameters(){
		return parameters;
	}
 
    
	public void setActive(boolean value){
		   active=value;		
	   }
    
	   public boolean isActive(){
		   return active;
	   }

	
	public String getId() {
		return id;
	}

	public String getReply() {
			return reply;
	}

	
	public void setId(String string) {
		id = string;
	}
	
	
	public void run(){
		reply=gateclient.send(gateaddress,servicename,request);
	}

	public String getRequest() {
		return request;
	}

	public void setRequest(String request) {
		this.request = request;
	}

}
