package nl.logicacmg.grid.client;
import java.io.File;
import java.io.FileInputStream;
import java.util.Properties;

import org.apache.log4j.Logger;

public  class PropertyManager {

	public static String filename = "client.properties";

	public static Properties properties;
	
	public static Logger logger=Logger.getLogger(PropertyManager.class);
	
	public static void init() {
		try {
			properties = new Properties();
			properties.load(
				new FileInputStream(new File(filename)));
		} catch (Exception e) {
			logger.error("Cannot load property file:"+filename);
		}
	}

	public static String getProp(String key) {
	    try{
	        String result = properties.getProperty(key);
	    logger.debug(key);
		return result.trim();
	    }
		catch (Exception e){
		    logger.error("Cannot find property '"+key+"', check your properties file.");
			return null;
		}
	}
	
	public static int getPropAsInt(String key){
		return Integer.parseInt(getProp(key));
	}
    
	public static double getPropAsDouble(String key){
		return Double.parseDouble(getProp(key));
	}
    
	public static boolean getPropAsBoolean(String key){
		return getProp(key).toUpperCase().equals("TRUE");
	}
    
	public static int getHugeCalcWitdh(){
	    return getPropAsInt("hugecalc_width");
	}
	
	public static int getHugeCalcHeight(){
	    return getPropAsInt("hugecalc_height");
	}
	
	public static double getHugeCalcMinx(){
	    return getPropAsDouble("hugecalc_minx");
	}
	
	public static double getHugeCalcMaxx(){
	    return getPropAsDouble("hugecalc_maxx");
	}
	
	public static double getHugeCalcMiny(){
	    return getPropAsDouble("hugecalc_miny");
	}
	
	public static double getHugeCalcMaxy(){
	    return getPropAsDouble("hugecalc_maxy");
	}
	
	public static int getHugeCalcInterations(){
	    return getPropAsInt("hugecalc_iterations");
	}
	
	public static String getGateClientClass(){
	    return getProp("gateclient_class");
	}
	
	public static boolean getBrokerDrawInfo(){
	    return getPropAsBoolean("broker_drawinfo");
	}
	
	public static int getViewerWidth(){
	    return getPropAsInt("viewer_width");
	}
	
	public static int getViewerHeight(){
	    return getPropAsInt("viewer_height");
	}
	
	public static String getColorPeaks(){
	    return getProp("colorpeaks");
	}
}
