package nl.logicacmg.grid.generic;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.StreamCorruptedException;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;

import org.apache.log4j.Logger;

/**
 * Marshaller-Demarshaller
 * @author WMulder
 *
 */
public class Madem {
    static Base64 base64=new Base64();
    static Logger logger=Logger.getLogger(Service.class);
 

	public static byte[] object2ByteArray(Object o) {
		byte[] b = null;
		
		try {
			ByteArrayOutputStream bout = new ByteArrayOutputStream();
			ZipOutputStream zipped =new ZipOutputStream(bout);
			zipped.putNextEntry(new ZipEntry("default"));
			ObjectOutputStream out = new ObjectOutputStream(zipped);
			out.writeObject(o);
			out.close();
			bout.close();
			b = bout.toByteArray();
			logger.debug("did object2ByteArray ("+o.getClass().getName()+" size,"+b.length+" bytes)");
		} catch (IOException e) {
			logger.fatal(e);
			}
		return b;
	}


	public static Object byteArray2Object(byte[] b) {
		Object object = null;
		ObjectInputStream in;
		try {
			ZipInputStream zippedin=new ZipInputStream(new ByteArrayInputStream(b));
			ZipEntry entry = zippedin.getNextEntry();
			in = new ObjectInputStream(zippedin);
			object = in.readObject();
			in.close();
			logger.debug("did byteArray2Object ("+object.getClass().getName()+")");
		} catch (StreamCorruptedException e) {
			logger.fatal(e);
		} catch (IOException e) {
			logger.fatal(e);
		} catch (ClassNotFoundException e) {
		   logger.fatal(e);
					
		}

		return object;
	}
	
	public static String base64(Object o){
		byte[] b=object2ByteArray(o);
		String result=base64.encode(b);
		return result;
		
	}
	
	public static Object object(String base64str){
		byte[] b=base64.decode(base64str);
		Object result=byteArray2Object(b);
		return result;
	}

}
