package nl.logicacmg.grid.service.mandelbrot;

import nl.logicacmg.grid.generic.Request;

public class MandelbrotRequest extends Request{
	private double minx;
	private double miny;
	private double maxx;
	private double maxy;
	private int width;
	private int height;
	private int iterations;
	private int[][] colorpeaks;
	 	
	public MandelbrotRequest(int width, int height, double minx, double miny, double maxx, double maxy, int iterations, int[][]colorpeaks) {
	super();
	this.width=width;
	this.height=height;
	this.minx=minx;
	this.miny=miny;
	this.maxx=maxx;
	this.maxy=maxy;
	this.iterations=iterations;
	this.colorpeaks=colorpeaks;
	}

	public int getHeight() {
		return height;
	}
	public int getIterations() {
		return iterations;
	}

	public double getMaxx() {
		return maxx;
	}

	public double getMaxy() {
		return maxy;
	}

	public double getMinx() {
		return minx;
	}

	public double getMiny() {
		return miny;
	}

	public int getWidth() {
		return width;
	}

    public int[][] getColorpeaks(){
    	return colorpeaks;
    }
}

